if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_CallCenter_Temp_UpdateCatTables' ))
	Drop procedure dbo.A_CallCenter_Temp_UpdateCatTables
GO


Create procedure [dbo].[A_CallCenter_Temp_UpdateCatTables]
as 

begin

	-- operators
	Update cat
	Set cat.Name = s.Name
	From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Operator] cat, A_Users s
	Where cat.Id = s.Id

	Insert Into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Operator]
	Select Id, Name
	From A_Users s
	Where Not Exists ( Select Id From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Operator] cat Where cat.Id = s.Id )

	declare @cnt int
	Select @cnt = Count ( * ) from [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Operator]
	Where Id = 'AB000000-0000-0000-0000-000000000000'
	if ( @cnt = 0 )
		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Operator] ( Id, Name )
		Values ( 'AB000000-0000-0000-0000-000000000000', 'IVR' )



	-- tasks
	Update cat
	Set cat.Name = s.Name
	From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task] cat, A_TaskManager_Tasks s
	Where cat.Id = s.Id

	Insert Into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task]
	Select Id, Name
	From A_TaskManager_Tasks s
	Where Not Exists ( Select Id From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task] cat Where cat.Id = s.Id )

end
GO



if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_CallCenter_Temp_FillTables' ))
	Drop procedure dbo.A_CallCenter_Temp_FillTables
GO


Create  Procedure [dbo].[A_CallCenter_Temp_FillTables]
as
begin
	--------      ---------------------------------------------------
	/*
	PriorHandle		= 1,
	WaitingCall		= 2,
	BackRing		= 3,
	TalkAbonent		= 4,
	TalkInside		= 5,
	WaitingInside		= 6,
	PostHandle		= 7,
	TalkOther		= 8,
	CCLunch			= 9,
	CCReady			= 10
	*/
	declare @cnt int
	Select @cnt = Count ( * ) From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
	if ( @cnt < 10 )
	   begin
		Delete From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes]
	
		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
		Values ( 1, N' ' )
	
		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
		Values ( 2, N'  ' )

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
		Values ( 3, N' ' )

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
		Values ( 4, N'  ' )

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
		Values ( 5, N'  ' )

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
		Values ( 6, N'  ' )-- '  Call-'

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
		Values ( 7, N' ' )

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
		Values ( 8, N' ' )

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
		Values ( 9, N'' )

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
		Values ( 10, N'' )
	   end
	

	--------    ---------------------------------------------------

	/*
		Success						= 5,	//    .       
		NoSuccess					= 18,	// (   -   ).   ,      
		// 
		Undefined					= 1,	//  .   - . (    ,      -,    )
		AbonentHangOff				= 13,	//           .      
		AbortCalling				= 15,	//     (   ) (?)
		AbortQueue					= 19,	//    , ( ?)
		// 
		StopCallNumber				= 16,	//    (   ).     
		StopCallAbonent				= 17,	//   (   ).     
		ListChanged					= 12,	//    
		RemovedByOperator			= 20,	//      .       
		// 
		Busy						= 2,	//.   ,       (     ).   
		NotRespond					= 3,	// .   ,       (     ).   
		TimeNotSufficient			= 4,	//   .    ivr.     .                     .   ,  
		NeedLater					= 8,	//  (   ).     
		OperatorSkipCall			= 6,	//      "".     .
		// 
		// 
		lrOperatorAbsent			= 7,		
		ChangeNumber				= 29 // 
	*/

	Select @cnt = Count ( * ) From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
	if ( @cnt < 27 )
	   begin
		Delete From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes]
	
		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 5, N'' )--success
	
		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 18, N'' )--nosuccess

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 1, N'' )--undefined

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 13, N'    ' )--abonenthangoff

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 15, N'  ' )--abortcalling

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 19, N'  ' )--abortqueue

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 16, N'   ' )--stopcallnumber

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 17, N'   ' )--stopcallabonent

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 12, N'   ' )--listchanged

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 20, N' ' )--removedbyoperator

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 31, N' ' )--faxdetected

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 2, N'' )--busy

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 3, N' ' )--notrespond

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 4, N'  ' )--timenotsufficient

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 8, N' ' )--needlater

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 6, N' ' )--operatorskipcall

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 7, N' ' )--operatorabsent

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 29, N'   ' )--IncomingOutTaskNotFound



		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 21, N' .   ' )--IncomingOutMaxCount

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 22, N'    ' )--IncomingOutPeriod	

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 23, N'   ' )--IncomingOutTimeTable

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 24, N'    ' )--IncomingOutActivityParams

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 25, N'    ' )--IncomingOutQueueTimeout

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 26, N' .  ' )--IncomingOutNoOperators

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 27, N' .  ' )--IncomingOutAllBusy

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 28, N' .     ' )--IncomingOutTaskNotFound

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 30, N'    ' ) -- IncomingOutAbonentNotFound

	   end
	
end
GO


If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_cc_temp' )
	If exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes]' ) )
	begin
		if not exists ( Select Id FROM [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] Where Id = 31 )
			Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
			Values ( 31, N' ' )--faxdetected
	end
GO

