if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Stat_DTMF' ) )
	Drop table dbo.A_Stat_DTMF
GO

Create table dbo.A_Stat_DTMF
(
	DT DateTime,
	LineId uniqueidentifier,
	Symbol nvarchar ( 5 )	
)
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Stat_DTMF_Save' ) )
	Drop procedure dbo.A_Stat_DTMF_Save
GO

Create procedure dbo.A_Stat_DTMF_Save
	@dt datetime = null,
	@line uniqueidentifier,
	@symbol nvarchar ( 5 )
as
begin
	Insert into A_Stat_DTMF ( DT, LineID, Symbol )
	Values ( @dt, @line, @symbol )
end
GO


if not exists ( select name from sysindexes where id=object_id('dbo.A_Stat_DTMF') and name = 'idxStatDTMF_DT' )
	CREATE INDEX idxStatDTMF_DT ON dbo.A_Stat_DTMF
	(
		DT
	) WITH FILLFACTOR = 80
GO

