
if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_TaskManager_List_DistrDirectDB_RefreshOperator' ) )
	Drop procedure dbo.A_TaskManager_List_DistrDirectDB_RefreshOperator
GO

Create procedure dbo.A_TaskManager_List_DistrDirectDB_RefreshOperator
	@taskid uniqueidentifier,
	@operatorid uniqueidentifier,
	@listtable nvarchar ( 1000 ) = '',
	@listquery nvarchar ( 4000 ) = '',
	@listidfield nvarchar ( 200 ) = '',
	@listnamefield nvarchar ( 200 ) = '',
	@count int = 0,
	@letter1 char ( 1 ) = '',
	@letter2 char ( 1 ) = ''
as
begin
	declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	declare @operator nvarchar ( 60 )
	set @operator = '''' + cast ( @operatorid as nvarchar ( 50 ) ) + ''''

	declare @sql nvarchar ( 4000 )

	--    ,    
	if exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		if ( @count > 0 )
  		    Set @sql = '
			SET ROWCOUNT ' + cast ( @count as nvarchar ( 10 ) ) + '

			Update ' + @tableidx + ' 
			Set IdOperator = ' + @operator + '
			Where IdOperator is null

			SET ROWCOUNT 0
			'

		else if (( @letter1 != '' ) and ( @letter2 != '' ) and ( @listtable != '' ))
		    Set @sql = '
			Declare @temp table ( id int primary key )
			Insert into @temp 
				Select Distinct ' + @listidfield + ' 
				From ' + @listtable + '
				Where Cast ( Substring ( ' + @listnamefield + ', 1, 1 ) as char ( 1 ) ) between ''' + @letter1 + ''' and ''' + @letter2 + '''
			
			Update a
			Set IdOperator = ' + @operator + '
			From ' + @tableidx + ' a, @temp b
			Where a.Id = b.Id
			'

		else if (( @letter1 != '' ) and ( @letter2 != '' ) and ( @listquery != '' ))
		    Set @sql = '
			Declare @temp table ( id int primary key )
			Insert into @temp 
				Select Distinct ' + @listidfield + ' 
				From (' + @listquery + ') a
				Where Cast ( Substring ( ' + @listnamefield + ', 1, 1 ) as char ( 1 ) ) between ''' + @letter1 + ''' and ''' + @letter2 + '''
			
			Update a
			Set IdOperator = ' + @operator + '
			From ' + @tableidx + ' a, @temp b
			Where a.Id = b.Id
			'

		else 
		    Set @sql = '
			Update ' + @tableidx + ' 
			Set IdOperator = NULL
			Where IdOperator = ''00000000-0000-0000-0000-000000000000'''

			
		exec sp_sqlexec @sql
	end
end
GO

