if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_ServerExtLines' ) )
	if not Exists ( Select * From INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_ServerExtLines' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'LineCode' )
	Alter Table dbo.A_ServerExtLines
	Add LineCode nvarchar ( 200 ) NULL
GO

if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_ServerGsmLines' ) )
	if not Exists ( Select * From INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_ServerGsmLines' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'LineCode' )
	Alter Table dbo.A_ServerGsmLines
	Add LineCode nvarchar ( 200 ) NULL
GO

if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_ServerIntLines' ) )
	if not Exists ( Select * From INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_ServerIntLines' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'LineCode' )
	Alter Table dbo.A_ServerIntLines
	Add LineCode nvarchar ( 200 ) NULL
GO

if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_ServerUsbLines' ) )
	if not Exists ( Select * From INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_ServerUsbLines' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'LineCode' )
	Alter Table dbo.A_ServerUsbLines
	Add LineCode nvarchar ( 200 ) NULL
GO

if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_ServerSipLines' ) )
	if not Exists ( Select * From INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_ServerSipLines' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'LineCode' )
	Alter Table dbo.A_ServerSipLines
	Add LineCode nvarchar ( 200 ) NULL
GO

if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_ServerVirtualLines' ) )
	if not Exists ( Select * From INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_ServerVirtualLines' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'LineCode' )
	Alter Table dbo.A_ServerVirtualLines
	Add LineCode nvarchar ( 200 ) NULL
GO

Update A_ServerExtLines
Set LineCode = ''
Where LineCode is null

Update A_ServerGsmLines
Set LineCode = ''
Where LineCode is null

Update A_ServerIntLines
Set LineCode = ''
Where LineCode is null

Update A_ServerUsbLines
Set LineCode = ''
Where LineCode is null

Update A_ServerSipLines
Set LineCode = ''
Where LineCode is null

Update A_ServerVirtualLines
Set LineCode = ''
Where LineCode is null
GO



if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_View_ServerLinesAll' ) )
	Drop view dbo.A_View_ServerLinesAll
GO

Create View [dbo].[A_View_ServerLinesAll]
as
	--   
	Select Id, Type, ServerId, SystemNum, Enabled, Caption, LineCode
	From A_ServerExtLines
	
	Union 
	
	Select Id, Type, ServerId, SystemNum, Enabled, Caption, LineCode
	From A_ServerGsmLines
	
	Union 

	Select Id, Type, ServerId, SystemNum, Enabled, Caption, LineCode
	From A_ServerIntLines
	
	Union 

	Select Id, Type, ServerId, SystemNum, Enabled, Caption, LineCode
	From A_ServerUsbLines

	Union
	
	Select Id, Type, ServerId, SystemNum, Enabled, Caption, LineCode
	From A_ServerSipLines

	Union

	Select Id, Type, ServerId, SystemNum, Enabled, Caption, LineCode
	From A_ServerVirtualLines

GO

if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_View_LineStates' ) )
	Drop view dbo.A_View_LineStates
GO

Create View dbo.A_View_LineStates
AS
--   
	Select Id, Enabled, Type, OwnerId, React, ServerId, ReactServer, Caption, Connected, SystemNum, LineCode
	From ( 
		Select a.Id, a.Enabled, a.Type, a.ServerId as OwnerId, WP1.ID AS react, 
			case WP1.type when 5 then WP1.ID else WP1.parentID end as ServerID , 
			WP1.Type AS reactserver, a.Caption, 0 as connected, a.SystemNum, LineCode
		
		From A_View_ServerLinesAll a
			Inner Join  dbo.A_LinesReactors LR ON a.ID = LR.LineID 
			Inner Join  dbo.A_WorkPlaces WP1 ON LR.WPID = WP1.ID
		
		
		Union
	
	
		Select a.Id, a.Enabled, a.Type, a.ServerId as OwnerId, null AS React,  
			a.ServerId as ServerId , null AS reactserver, a.Caption, 1 as connected, a.SystemNum, LineCode
		
		From A_View_ServerLinesAll a 
		Where not a.ID in ( Select LineID From A_LinesReactors )
	)b	
GO


if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Line_GetLineStates' ) )
	Drop procedure dbo.A_Line_GetLineStates
GO

Create Procedure dbo.A_Line_GetLineStates
as
begin
	Select ID, Enabled, Type, OwnerID, React, ServerID, reactserver, connected, SystemNum, LineCode 
	From A_View_LineStates 
	Order By SystemNum
end
GO


if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Admin_Lines_Ext_Get' ) )
	Drop procedure dbo.A_Admin_Lines_Ext_Get
GO

Create Procedure [dbo].A_Admin_Lines_Ext_Get
	@id	uniqueidentifier
as
begin

	Select 	
		e.Id,		
		w.Name, 
		w.Id,
		Cast ( e.SystemNum as nvarchar(20) ) as SystemNum,
		Cast ( e.Enabled as bit ) as Enabled, 
		Cast ( e.CanSimpleOut as bit ) as CanSimpleOut,
		Cast ( e.CanIp as bit ) as CanIp, 
		Cast ( e.CanAutoDial as bit ) as CanAutoDial,
		Cast ( e.CanMobile as bit ) as CanMobile, 
		e.Prefix,
		e.ExtNumber,
		e.Caption,
		e.DialType,
		e.ConnectedPBX,
		e.Type,
		e.StreamId,
		st.Name as StreamName,
		LineCode
	
	From A_ServerExtLines e 
		Inner Join A_WorkPlaces w on e.ServerID = w.ID
		Left Join A_ServerStreams st on e.StreamId = st.Id

	Where ( e.ServerID = @id ) or ( @id = '00000000-0000-0000-0000-000000000000' )

	Order By SystemNum
end
GO


if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Admin_Lines_Int_Get' ) )
	Drop procedure dbo.A_Admin_Lines_Int_Get
GO

Create Procedure [dbo].A_Admin_Lines_Int_Get
	@id	uniqueidentifier
as
begin
   --    .
   --  0  - 
   --    -   (  CTI)

   Declare @groups table ( groupid uniqueidentifier, groupname nvarchar ( 255 ) collate database_default)
   Insert into @groups
	Select Id, Name 
	From A_Groups
   Insert Into @groups ( groupid, groupname )
	Values ( '00000000-0000-0000-0000-000000000000', '' )


   if ( @id = '00000000-0000-0000-0000-000000000000' )
   begin
	Select 
		e.Id,
		w.Name,
		w.Id,
		Cast ( e.SystemNum as nvarchar(20) ) as SystemNum,
		Cast ( e.Enabled as bit ) as Enabled,		
		Cast ( e.CityStraight as bit ) as CityStraight, 
		e.caption,
		e.ServerId,
		e.Type,
		e.ParentGroupId,
		g.GroupName,
		e.Address,
		e.StreamId,
		st.Name as StreamName,
		e.BusyMode,
		e.LineCode
	FROM 
	(	
		Select 	Id,
			systemnum, 
			enabled, 
			citystraight, 
			caption, 
			ServerID,
			Type,
			ParentGroupId,
			'' as Address,
			Cast ( NULL as uniqueidentifier ) as StreamId,
			Cast ( NULL as int ) as BusyMode,
			LineCode
		From A_ServerIntLines

		Union All

		Select 	Id,
			systemnum, 
			enabled, 
			citystraight, 
			caption, 
			ServerID,
			Type,
			ParentGroupId,
			'' as Address,
			Cast ( NULL as uniqueidentifier ) as StreamId,
			Cast ( NULL as int ) as BusyMode,
			LineCode
		From A_ServerUsbLines
		
		Union All

		Select 	Id,
			systemnum, 
			enabled, 
			citystraight, 
			caption, 
			ServerID,
			Type,
			ParentGroupId,
			Address,
			StreamId,
			BusyMode,
			LineCode
		From A_ServerSipLines


		Union All

		Select 	Id,
			systemnum, 
			enabled, 
			citystraight, 
			caption, 
			ServerID,
			Type,
			ParentGroupId,
			Address,
			Cast ( NULL as uniqueidentifier ) as StreamId,
			Cast ( NULL as int ) as BusyMode,
			LineCode
		From A_ServerVirtualLines
	) e
	
		Inner join A_WorkPlaces w on e.ServerID = w.ID
		Inner join @groups g on e.ParentGroupId = g.GroupId
		Left join A_ServerStreams st on e.StreamId = st.Id

	Order By SystemNum
    
   end
   else
   begin
	
	Select 
		e.Id,
		w.Name,
		w.Id,
		Cast ( e.SystemNum as nvarchar(20) ) as SystemNum,
		Cast ( e.Enabled as bit ) as Enabled,		
		Cast ( e.CityStraight as bit ) as CityStraight, 
		e.caption,
		e.ServerId,
		e.Type,
		e.ParentGroupId,
		g.GroupName,
		e.Address,
		e.StreamId,
		st.Name as StreamName,
		e.BusyMode,
		e.LineCode
	
	FROM 
	(	
		Select 
			Id,
			systemnum, 
			enabled, 
			citystraight, 
			caption, 
			ServerID,
			Type,
			ParentGroupId,
			'' as Address,
			Cast ( NULL as uniqueidentifier ) as StreamId,
			Cast ( NULL as int ) as BusyMode,
			LineCode
		From A_ServerIntLines
		
	) e
	
		Inner join A_WorkPlaces w on e.ServerID = w.ID
		Inner join @groups g on e.ParentGroupId = g.GroupId
		Left join A_ServerStreams st on e.StreamId = st.Id

	Where e.ServerId = @id
	Order By SystemNum
    end	

end
GO



if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Admin_Line_Ext_Set' ) )
	Drop procedure dbo.A_Admin_Line_Ext_Set
GO

Create Procedure [dbo].A_Admin_Line_Ext_Set
	@id			uniqueidentifier,
	@extnumber		nvarchar ( 200 ),
	@canautodial		bit,
	@canipout		bit,
	@canmobile		bit,
	@cansimpleout		bit,
	@caption		nvarchar ( 200 ),
	@dt			int,
	@enabled		bit,
	@prefix			nvarchar ( 200 ),
	@connectedpbx		bit,
	@type			int = 1,
	@linecode		nvarchar ( 200 ) = ''
as
begin

	Update A_ServerExtLines 
	Set 
		ExtNumber 	= @extnumber,
		CanAutoDial 	= @canautodial,
		CanIp 		= @canipout,
		CanMobile 	= @canmobile,
		CanSimpleOut 	= @cansimpleout,
		Caption 	= @caption,
		DialType 	= @dt,
		Enabled 	= @enabled,
		Prefix 		= @prefix,
		ConnectedPBX	= @connectedpbx,
		Type		= @type,
		LineCode	= @linecode
	Where
		Id = @id
		
end
GO



if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Admin_Line_Int_Set' ) )
	Drop procedure dbo.A_Admin_Line_Int_Set
GO

Create Procedure [dbo].A_Admin_Line_Int_Set
	@id			uniqueidentifier,
	@citystraight		bit,
	@caption		nvarchar ( 200 ),
	@enabled		bit,
	@parentgroupid		uniqueidentifier,
	@linecode		nvarchar ( 200 ) = ''

as
begin
--     

	Update A_ServerIntLines 
	Set 	CityStraight 	= @citystraight,
		Caption 	= @caption,
		Enabled 	= @enabled,
		ParentGroupId	= @parentgroupid,
		LineCode	= @linecode
	Where	Id = @id

	Update A_ServerUsbLines 
	Set 	CityStraight 	= @citystraight,
		Caption 	= @caption,
		Enabled 	= @enabled,
		ParentGroupId	= @parentgroupid,
		LineCode	= @linecode
	Where	Id = @id
		
	Update A_ServerSipLines 
	Set 	CityStraight 	= @citystraight,
		Caption 	= @caption,
		Enabled 	= @enabled,
		ParentGroupId	= @parentgroupid,
		LineCode	= @linecode
	Where	Id = @id

	Update A_ServerVirtualLines 
	Set 	CityStraight 	= @citystraight,
		Caption 	= @caption,
		Enabled 	= @enabled,
		ParentGroupId	= @parentgroupid,
		LineCode	= @linecode
	Where	Id = @id
end
GO