
-------------------------------------------------------------------------------------
------------------------------ A_User_NotifyLog---------------------------
-------------------------------------------------------------------------------------


/******   :  Index [PK_A_User_NotifyLog]     ******/
IF  EXISTS (select name from sysobjects
			where xtype='PK'
			and parent_obj=OBJECT_ID('dbo.A_User_NotifyLog'))
begin
declare @comm nvarchar (1000)
set @comm = 'ALTER TABLE [dbo].[A_User_NotifyLog] DROP CONSTRAINT [' +
			(select name from sysobjects
			where xtype='PK'
			and parent_obj=OBJECT_ID('dbo.A_User_NotifyLog')) + ']';
exec sp_executesql @comm
end
GO


/******   :  Index [idxUserNotifies_UserDTWasShown]    ******/
IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[A_User_NotifyLog]') AND name = N'idxUserNotifies_DT')
CREATE CLUSTERED INDEX [idxUserNotifies_DT] ON [dbo].[A_User_NotifyLog] 
(
	[NotifyDateTime]
)WITH FILLFACTOR = 100 ON [PRIMARY]
GO


/******   :  Index [idxUserNotifies_DT]     ******/
IF  EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[A_User_NotifyLog]') AND name = N'idxUserNotifies_DT')
DROP INDEX [dbo].[A_User_NotifyLog].[idxUserNotifies_DT]
GO

-------------------------------------------------------------------------------------
---------------------- [A_CallCenter_UserStateHistory] -------------------
-------------------------------------------------------------------------------------


/****** Object:  Index [PK__A_CallCenter_Us]    Script Date: 04/28/2010 13:36:49 ******/
IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[A_CallCenter_UserStateHistory]') AND name = N'idx_A_CallCenter_OppID')
CREATE NONCLUSTERED INDEX [idx_A_CallCenter_OppID] ON [dbo].[A_CallCenter_UserStateHistory] 
(
	[OperatorId] ASC
)WITH FILLFACTOR = 80 ON [PRIMARY]
GO


/****** Object:  Index [PK__A_CallCenter_Us]    Script Date: 04/28/2010 13:38:37 ******/
IF  EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[A_CallCenter_UserStateHistory]') AND name = N'PK__A_CallCenter_Us')
ALTER TABLE [dbo].[A_CallCenter_UserStateHistory] DROP CONSTRAINT [PK__A_CallCenter_Us]
GO

-------------------------------------------------------------------------------------
------------------------ A_TaskManager_SubTaskEfforts---------------------
-------------------------------------------------------------------------------------

/****** Object:  Index [PK_A_TaskManager_SubTaskEfforts]     ******/
IF  EXISTS (select name from sysobjects
			where xtype='PK'
			and parent_obj=OBJECT_ID('dbo.A_TaskManager_SubTaskEfforts'))
begin
declare @comm nvarchar (1000)
set @comm = 'ALTER TABLE [dbo].[A_TaskManager_SubTaskEfforts] DROP CONSTRAINT [' +
			(select name from sysobjects
			where xtype='PK'
			and parent_obj=OBJECT_ID('dbo.A_TaskManager_SubTaskEfforts')) + ']';
exec sp_executesql @comm
end
GO


/****** Object:  Index [idxSubTaskId]     ******/
IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[A_TaskManager_SubTaskEfforts]') AND name = N'idx_SubTask_EDT')
CREATE CLUSTERED INDEX [idx_SubTask_EDT] ON [dbo].[A_TaskManager_SubTaskEfforts] 
(
	[EDateTime] ASC
)WITH FILLFACTOR = 100 ON [PRIMARY]
GO

/****** Object:  Index [PK_A_TaskManager_SubTaskEfforts]     ******/
IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[A_TaskManager_SubTaskEfforts]') AND name = N'PK_A_TaskManager_SubTaskEfforts_ID')
ALTER TABLE [dbo].[A_TaskManager_SubTaskEfforts] ADD  CONSTRAINT [PK_A_TaskManager_SubTaskEfforts_ID] PRIMARY KEY nonCLUSTERED 
(
	[Id] ASC
)WITH FILLFACTOR = 80 ON [PRIMARY]
GO


-------------------------------------------------------------------------------------
--------------------------- A_TaskManager_SubTasks------------------------
-------------------------------------------------------------------------------------


/****** Object:  Index [idx_SubTasks_TId_IdP]    Script Date: 04/28/2010 17:27:16 ******/
IF  EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[A_TaskManager_SubTasks]') AND name = N'idx_SubTasks_TId_IdP')
DROP INDEX [dbo].[A_TaskManager_SubTasks].[idx_SubTasks_TId_IdP]
GO



/****** Object:  Index [PK_A_TaskManager_SubTasks]    Script Date: 04/28/2010 17:26:38 ******/
IF  EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[A_TaskManager_SubTasks]') AND name = N'PK_A_TaskManager_SubTasks')
ALTER TABLE [dbo].[A_TaskManager_SubTasks] DROP CONSTRAINT [PK_A_TaskManager_SubTasks]
GO



/****** Object:  Index [PK_A_TaskManager_SubTasks]    Script Date: 04/28/2010 16:58:46 ******/
IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[A_TaskManager_SubTasks]') AND name = N'PK_A_TaskManager_SubTasks_tID_idIL')
ALTER TABLE [dbo].[A_TaskManager_SubTasks] ADD  CONSTRAINT [PK_A_TaskManager_SubTasks_tID_idIL] PRIMARY KEY CLUSTERED 
(
	[TaskId] ASC,
	[IdInList] ASC
)WITH FILLFACTOR = 80 ON [PRIMARY]
GO


-------------------------------------------------------------------------------------
----------------------- [A_TaskManager_SubTaskNumber]---------------------
-------------------------------------------------------------------------------------


/****** Object:  Index [PK_A_TaskManager_SubTaskNumber]    Script Date: 04/28/2010 17:56:48 ******/
IF  EXISTS (select name from sysobjects
			where xtype='PK'
			and parent_obj=OBJECT_ID('dbo.A_TaskManager_SubTaskNumber'))
begin
declare @comm nvarchar (1000)
set @comm = 'ALTER TABLE [dbo].[A_TaskManager_SubTaskNumber] DROP CONSTRAINT [' +
			(select name from sysobjects
			where xtype='PK'
			and parent_obj=OBJECT_ID('dbo.A_TaskManager_SubTaskNumber')) + ']';
exec sp_executesql @comm
end
GO


/****** Object:  Index [PK_A_TaskManager_SubTaskNumber]    Script Date: 04/28/2010 17:49:09 ******/
IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[A_TaskManager_SubTaskNumber]') AND name = N'PK_A_TaskManager_SubTaskNumber_tID_idIL')
ALTER TABLE [dbo].[A_TaskManager_SubTaskNumber] ADD  CONSTRAINT [PK_A_TaskManager_SubTaskNumber_tID_idIL] PRIMARY KEY CLUSTERED 
(
	[TaskId] ASC,
	[IdInList] ASC,
	[Number] asc
) WITH FILLFACTOR = 80 ON [PRIMARY]
GO


