if exists ( Select * FROM sysobjects where id=object_id ( 'dbo.A_DB_ClearConstraints' ))
	Drop procedure dbo.A_DB_ClearConstraints
GO

Create procedure [dbo].[A_DB_ClearConstraints]
	@simpletablename nvarchar ( 500 )
as
begin
	--     (  )
	--    ?
	
	Declare @tablename varchar ( 500 )
	Declare @sql nvarchar(1000)
	Set @tablename='dbo.' + @simpletablename

	Declare tcursor Cursor For 
		Select s.name, s.parent_obj, s1.name
		From sysobjects s
			Inner join sysobjects s1 on s1.Id = s.parent_obj
		Where ( s.type = 'F' )
			and s.parent_obj = object_id ( @tablename )

	Declare @cnstrname varchar(500)
	Declare @parent int
	Declare @subtab varchar ( 500 )


	Open tcursor
	Fetch Next From tcursor Into @cnstrname, @parent, @subtab

	While ( @@fetch_status = 0 ) Begin

		set @sql = ' ALTER TABLE ' + @subtab + 
			' DROP CONSTRAINT ' + @cnstrname
		exec sp_executesql @stmt =@sql
		print @sql

		Fetch Next From tcursor Into @cnstrname, @parent, @subtab
	End
	
	Close tcursor
	Deallocate tcursor

End
GO


if exists ( Select * FROM sysobjects where id=object_id ( 'dbo.A_DB_ClearConstraintsAll' ))
	Drop procedure dbo.A_DB_ClearConstraintsAll
GO

Create procedure [dbo].[A_DB_ClearConstraintsAll]
	@simpletablename nvarchar ( 500 )
as
begin
	
	--      (  )
	--    

	Declare @tablename varchar ( 500 )
	Declare @sql nvarchar(1000)
	Set @tablename='dbo.' + @simpletablename

	Declare tcursor Cursor For 
		Select s.name, s.parent_obj, s1.name
		From sysobjects s
			Inner join sysobjects s1 on s1.Id = s.parent_obj
		Where ( s.type = 'F' or s.type = 'K' )
			and s.parent_obj = object_id ( @tablename )
		Order by s.type, s.Id Desc

	Declare @cnstrname varchar(500)
	Declare @parent int
	Declare @subtab varchar ( 500 )


	Open tcursor
	Fetch Next From tcursor Into @cnstrname, @parent, @subtab

	While ( @@fetch_status = 0 ) Begin

		Set @sql = ' ALTER TABLE ' + @subtab + 
			' DROP CONSTRAINT ' + @cnstrname
		Exec sp_executesql @stmt =@sql
		Print @sql

		Fetch Next From tcursor Into @cnstrname, @parent, @subtab
	End

	Close tcursor
	Deallocate tcursor

End
GO


if exists ( Select * From sysobjects Where id = object_id ( 'dbo.A_DB_DropTable' ) )
	Drop procedure dbo.A_DB_DropTable
GO

Create procedure dbo.A_DB_DropTable
	@simplename nvarchar ( 500 )
as
begin
	Exec A_DB_ClearIndexes @simplename
	Exec A_DB_ClearConstraints @simplename
	
	Declare @sqltext nvarchar(4000)	
	Set @sqltext = ' If exists ( select * from sysobjects where id = object_id ( ''dbo.[' + @simplename + ']'' ) and OBJECTPROPERTY(id, N''IsUserTable'') = 1)
			 Drop Table dbo.[' + @simplename + '] '
	
	Exec sp_executesql @sqltext
end
GO

if exists ( Select * From sysobjects Where id = object_id ( 'dbo.A_DB_DropObject' ) )
	Drop procedure dbo.A_DB_DropObject
GO

Create procedure dbo.A_DB_DropObject
	@simplename nvarchar ( 500 )
as
begin
	Exec A_DB_ClearIndexes @simplename
	Exec A_DB_ClearConstraints @simplename
	
	Declare @sqltext nvarchar(4000)	

	Set @sqltext = ' If exists ( select * from sysobjects where id = object_id ( ''dbo.[' + @simplename + ']'' ) and OBJECTPROPERTY(id, N''IsUserTable'') = 1)
	    Drop Table dbo.[' + @simplename + '] '	

	Exec sp_executesql @sqltext

	Set @sqltext = ' If exists ( select * from sysobjects where id = object_id ( ''dbo.[' + @simplename + ']'' ) and OBJECTPROPERTY(id, N''IsView'') = 1)
	    Drop View dbo.[' + @simplename + '] '	

	Exec sp_executesql @sqltext

	Set @sqltext = ' If exists ( select * from sysobjects where id = object_id ( ''dbo.[' + @simplename + ']'' ) and OBJECTPROPERTY(id, N''IsProcedure'') = 1)
	    Drop Procedure dbo.[' + @simplename + '] '	

	Exec sp_executesql @sqltext
end
GO
