
If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_settings' )
  If exists ( Select * From oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_Plugins' ))
    If not Exists ( Select * From oktell_settings.INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_Plugins' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'LogMode' )
	Alter Table oktell_settings.dbo.A_Plugins
	Add LogMode int
GO


If exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Plugins' ) and OBJECTPROPERTY(id, N'IsUserTable') = 1 )
  If not Exists ( Select * From INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_Plugins' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'LogMode' )
	Alter Table oktell_settings.dbo.A_Plugins
	Add LogMode int
GO

If exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Plugins' ) and OBJECTPROPERTY(id, N'IsView') = 1 )
	Drop view dbo.A_PlugIns
GO

Create View dbo.A_PlugIns
As
	Select *
	FROM oktell_settings.dbo.A_PlugIns
GO

Update A_Plugins
Set LogMode = 0
Where LogMode is NULL
GO

If exists ( Select * From sysobjects where id = object_id ( 'dbo.A_PlugIns_Save' ) and OBJECTPROPERTY(id, N'IsProcedure') = 1 )
	Drop procedure dbo.A_PlugIns_Save
GO

Create procedure dbo.A_PlugIns_Save
	@id uniqueidentifier,
	@type int,
	@objectname nvarchar ( 400 ) = null,
	@name nvarchar ( 400 ),
	@description Text = null,
	@path nvarchar ( 1000 ) = null,
	@loadtype int = 1,
	@loadmoment int = 0,
	@destination int = 1,
	@logmode int = 0
as
begin
	Update A_PlugIns
	Set 	Type = @type,
		ObjectName = @objectname,
		Name = @name,
		Description = @description,
		Path = @path,
		LoadType = @loadtype,
		LoadMoment = @loadmoment,
		Destination = @destination,
		LogMode = @logmode
	Where Id = @id

	if ( @@rowcount = 0 )
		Insert 
		Into A_PlugIns ( Id, Type, ObjectName, Name, Description, Path, LoadType, LoadMoment, Destination, LogMode )
		Values ( @id, @type, @objectname, @name, @description, @path, @loadtype, @loadmoment, @destination, @logmode )
end
GO


If exists ( Select * From sysobjects where id = object_id ( 'dbo.A_PlugIns_GetAll' ) and OBJECTPROPERTY(id, N'IsProcedure') = 1 )
	Drop procedure dbo.A_PlugIns_GetAll
GO

Create procedure dbo.A_PlugIns_GetAll
as
begin
	Select Id, Type, ObjectName, Name, Description, Path, LoadType, LoadMoment, Destination, LogMode
	From A_PlugIns
	Order by Name	
end
GO

