if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_TaskManager_List_DirectDB_SyncQuery' ))
	Drop procedure dbo.A_TaskManager_List_DirectDB_SyncQuery
GO

Create procedure A_TaskManager_List_DirectDB_SyncQuery
	@taskid uniqueidentifier,
	@query nvarchar ( 4000 ),
	@fields nvarchar ( 2000 ),
	@idfield nvarchar ( 100 ) = 'Id'
as
begin
--------------------------------------
/*
Declare @taskid uniqueidentifier
Declare @table nvarchar ( 200 )

set @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF'
set @table = 'dbo.T_Test5mln'
*/
--------------------------------------

	Declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_Idx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
	Declare @tableacindex nvarchar ( 200 )
	Declare @tablestindex nvarchar ( 200 )
	set @tableacindex = 'idxTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'
--	set @tablestindex = 'idxTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_ST'

	Declare @sql nvarchar ( 4000 )

	--    ,    
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC, State ) With FillFactor = 80	

			'
--			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tablestindex + ']'' ) and name = ''' + @tablestindex + ''' )
--				Create Nonclustered Index [' + @tablestindex + '] ON ' + @tableidx + '
--				( State ) With FillFactor = 80	
--			'

		exec sp_sqlexec @sql
	end	
	

	--     100000     transactionlog
	Set @sql = '
		Declare @k int
		Set @k = 1
		Select @k = IsNull ( Min ( AC ), 0 ) From ' + @tableidx + '
		if ( @k > 0 )
			set @k = @k - 1

					Declare @temp int set @temp = 1 --    @@rowcount>0 

		While ( @@rowcount > 0 )
		begin
			Insert into ' + @tableidx + ' ( Id, AC, State, NIdx )				
			 	Select top 100000 t.[' + @idfield + '], @k, 0, 0
				From ( ' + @query + ') t
				Where not exists ( Select [Id] From ' + @tableidx + ' Where [Id] = t.[' + @idfield + '] )
		end
		'

	exec sp_sqlexec @sql

	
	--   STATE = 3    . (     )
	Set @sql = '
		Declare @cnta int
		Select @cnta = Count ( [' + @idfield + '] )
		From (' + @query + ')a
		
		Declare @cntb int
		Select @cntb = Count ( Id )
		From ' + @tableidx + '
	
		if ( @cntb != @cnta )
			Update t
			Set State = 3
			From ' + @tableidx + ' t
			Where not exists ( Select [' + @idfield + '] From ( ' + @query + ' ) a1 Where [' + @idfield + '] = t.[Id] )
		'

	exec sp_sqlexec @sql
end
GO


if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_TaskManager_List_DirectDB_SyncTable' ))
	Drop procedure dbo.A_TaskManager_List_DirectDB_SyncTable
GO

Create procedure A_TaskManager_List_DirectDB_SyncTable
	@taskid uniqueidentifier,
	@table nvarchar ( 200 ),
	@fields nvarchar ( 500 ),
	@idfield nvarchar ( 50 ) = 'Id'
as
begin
--------------------------------------
/*
Declare @taskid uniqueidentifier
Declare @table nvarchar ( 200 )

set @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF'
set @table = 'dbo.T_Test5mln'
*/
--------------------------------------

	Declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_Idx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
	Declare @tableacindex nvarchar ( 200 )
	Declare @tablestindex nvarchar ( 200 )
	set @tableacindex = 'idxTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'
--	set @tablestindex = 'idxTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_ST'

	Declare @sql nvarchar ( 4000 )

	--    ,    
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC, State ) With FillFactor = 80	
			'
--			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tablestindex + ']'' ) and name = ''' + @tablestindex + ''' )
--				Create Nonclustered Index [' + @tablestindex + '] ON ' + @tableidx + '
--				( State ) With FillFactor = 80	
--			'

		exec sp_sqlexec @sql
	end	
	

	--     100000     transactionlog
	Set @sql = '			
		Declare @k int
		Set @k = 1
		Select @k = IsNull ( Min ( AC ), 0 ) From ' + @tableidx + '
		if ( @k > 0 )
			set @k = @k - 1

		Declare @temp int set @temp = 1 --    @@rowcount>0 

		While ( @@rowcount > 0 )
		begin
			Insert into ' + @tableidx + ' ( Id, AC, State, NIdx )				
			 	Select top 100000 t.[' + @idfield + '], @k, 0, 0
				From ' + @table + ' t
				Where not exists ( Select Id From ' + @tableidx + ' Where Id = t.[' + @idfield + '] )
		end
		'

	exec sp_sqlexec @sql


	--   STATE = 3    . (     )
	Set @sql = '
		Declare @cnta int
		Select @cnta = Count ( [' + @idfield + '] )
		From ' + @table + '
		
		Declare @cntb int
		Select @cntb = Count ( Id )
		From ' + @tableidx + '

		if ( @cnta < @cntb )
			Update tac with ( tablock ) 
			Set State = 3
			From ' + @tableidx + ' tac 
			Where not exists ( Select [' + @idfield + '] From ' + @table + ' Where [' + @idfield + '] = tac.[Id] )'

	exec sp_sqlexec @sql
end
GO


if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_TaskManager_List_DistrDirectDB_SyncQuery' ))
	Drop procedure dbo.A_TaskManager_List_DistrDirectDB_SyncQuery
GO

Create procedure A_TaskManager_List_DistrDirectDB_SyncQuery
	@taskid uniqueidentifier,
	@query nvarchar ( 4000 ),
	@fields nvarchar ( 500 ),
	@idfield nvarchar ( 200 ) = 'Id'
as
begin
--------------------------------------
/*
Declare @taskid uniqueidentifier
Declare @table nvarchar ( 200 )

set @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF'
set @table = 'dbo.T_Test5mln'
*/
--------------------------------------

	Declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
	Declare @tableacindex nvarchar ( 200 )
	Declare @tableopindex nvarchar ( 200 )
	set @tableacindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'
	set @tableopindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_OP'

	Declare @sql nvarchar ( 4000 )

	--    ,    
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int, IdOperator uniqueidentifier )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC, State ) With FillFactor = 80	

			
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableopindex + ']'' ) and name = ''' + @tableopindex + ''' )
				Create Nonclustered Index [' + @tableopindex + '] ON ' + @tableidx + '
				( IdOperator ) With FillFactor = 80	
			'

		exec sp_sqlexec @sql
	end	
	

	--     100000     transactionlog
	Set @sql = '
		Declare @k int
		Set @k = 1
		Select @k = IsNull ( Min ( AC ), 0 ) From ' + @tableidx + '
		if ( @k > 0 )
			set @k = @k - 1

		Declare @temp int set @temp = 1 --    @@rowcount>0 

		While ( @@rowcount > 0 )
		begin
			Insert into ' + @tableidx + ' ( Id, AC, State, NIdx )				
			 	Select top 100000 t.[' + @idfield + '], @k, 0, 0
				From ( ' + @query + ') t
				Where not exists ( Select [Id] From ' + @tableidx + ' Where [Id] = t.[' + @idfield + '] )
		end
		'

	exec sp_sqlexec @sql

	
	--   STATE = 3    . (     )
	Set @sql = '
		Declare @cnta int
		Select @cnta = Count ( [' + @idfield + '] )
		From (' + @query + ')a
		
		Declare @cntb int
		Select @cntb = Count ( Id )
		From ' + @tableidx + '
	
		if ( @cntb != @cnta )
			Update t
			Set State = 3
			From ' + @tableidx + ' t
			Where not exists ( Select [' + @idfield + '] From ( ' + @query + ' ) a1 Where [' + @idfield + '] = t.[Id] )
		'

	exec sp_sqlexec @sql
end
GO


if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_TaskManager_List_DistrDirectDB_SyncTable' ))
	Drop procedure dbo.A_TaskManager_List_DistrDirectDB_SyncTable
GO

Create procedure A_TaskManager_List_DistrDirectDB_SyncTable
	@taskid uniqueidentifier,
	@table nvarchar ( 200 ),
	@fields nvarchar ( 2000 ),
	@idfield nvarchar ( 200 ) = 'Id'
as
begin
--------------------------------------
/*
Declare @taskid uniqueidentifier
Declare @table nvarchar ( 200 )

set @taskid = 'ABCDEF12-3456-7890-1234-ABCDEFABCDEF'
set @table = 'dbo.T_Test5mln'
*/
--------------------------------------

	Declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
	Declare @tableacindex nvarchar ( 200 )
	Declare @tableopindex nvarchar ( 200 )
	set @tableacindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_AC_ST'
	set @tableopindex = 'idxdTASK_' + cast ( @taskid as nvarchar ( 50 ) ) + '_OP'

	Declare @sql nvarchar ( 4000 )

	--    ,    
	if not exists ( select * from sysobjects where id = object_id ( @tableidx ) )
	begin
		Set @sql = '
			Create table ' + @tableidx + ' ( Id int primary key, AC int, State int, NIdx int, IdOperator uniqueidentifier )
	
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableacindex + ']'' ) and name = ''' + @tableacindex + ''' )
				Create Nonclustered Index [' + @tableacindex + '] ON ' + @tableidx + '
				( AC, State ) With FillFactor = 80	
			
			if not exists ( select name from sysindexes where id=object_id ( ''dbo.[' + @tableopindex + ']'' ) and name = ''' + @tableopindex + ''' )
				Create Nonclustered Index [' + @tableopindex + '] ON ' + @tableidx + '
				( IdOperator ) With FillFactor = 80	
			'			

		exec sp_sqlexec @sql
	end	
	

	--     100000     transactionlog
	Set @sql = '			
		Declare @k int
		Set @k = 1
		Select @k = IsNull ( Min ( AC ), 0 ) From ' + @tableidx + '
		if ( @k > 0 )
			set @k = @k - 1

		Declare @temp int set @temp = 1 --    @@rowcount>0 

		While ( @@rowcount > 0 )
		begin
			Insert into ' + @tableidx + ' ( Id, AC, State, NIdx )				
			 	Select top 100000 t.[' + @idfield + '], @k, 0, 0
				From ' + @table + ' t
				Where not exists ( Select Id From ' + @tableidx + ' Where Id = t.[' + @idfield + '] )
		end
		'

	exec sp_sqlexec @sql


	--   STATE = 3    . (     )
	Set @sql = '
		Declare @cnta int
		Select @cnta = Count ( [' + @idfield + '] )
		From ' + @table + '
		
		Declare @cntb int
		Select @cntb = Count ( Id )
		From ' + @tableidx + '

		if ( @cnta < @cntb )
			Update tac with ( tablock ) 
			Set State = 3
			From ' + @tableidx + ' tac 
			Where not exists ( Select [' + @idfield + '] From ' + @table + ' Where [' + @idfield + '] = tac.[Id] )'

	exec sp_sqlexec @sql
end
GO