if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Rules_GetForLineAndUser' ))
	Drop procedure dbo.A_Rules_GetForLineAndUser
GO

Create Procedure dbo.A_Rules_GetForLineAndUser
	@userid uniqueidentifier, 
	@lineid uniqueidentifier
as
Begin

	Declare @rc int
	Declare @rcl int
	Set @rcl = 0

	Declare @idempty uniqueidentifier
	Set @idempty = '00000000-0000-0000-0000-000000000000'

	Declare @rules table ( Id uniqueidentifier, Priority int )
	Declare @numbers table ( Id uniqueidentifier, Prefix nvarchar ( 20 ) collate database_default)

	Insert into @rules
	    Select R.[ID], R.Priority 
  	    From A_Rules R 
		Inner join A_RuleRecords RR on RR.RuleID = R.[ID]
	    Where ( RR.ReactId != @idempty ) 
		and (( RR.ReactID = @userid )
		    or ( RR.ReactID = @lineid )
		    or (RR.ReactId in (Select Id From @numbers)))


	Select @rc = Count ( * ) 
	From @rules

	Declare @cnt int
	Set @cnt = 0

	While (( @rc != @rcl ) And ( @cnt < 10 )) Begin
	    Set @cnt = @cnt + 1

	    Insert Into @numbers
		Select np.Id, np.Prefix
		From A_NumberPlan np
			Inner join A_NumberPlanAction npa on npa.NumId = np.id
			Inner join @rules R on npa.ExtraId = r.Id

	    Delete From @rules	
	
	    Insert into @rules
		Select R.[ID], R.Priority 
		From A_Rules R 
			Inner join A_RuleRecords RR on RR.RuleID = R.[ID]
		Where ( RR.ReactId != @idempty ) 
		    and (( RR.ReactID = @userid )
		    	or ( RR.ReactID = @lineid )
		    	or (RR.ReactId in (Select Id From @numbers)))

	    Set @rcl = @rc
	
	    Select @rc = Count ( * )
	    From @rules
	End

	Select Id, Priority
	From @rules
	Group By Id, Priority
	Order by Priority Desc

End
GO

